%global __requires_exclude devel\\\(libnss3.*\\\)|devel\\\(libnspr4.*\\\)|devel\\\(libsmime3.*\\\)
%global ppp_version %(sed -n 's/^#define\\s*PPPD_VERSION\\s*"\\([^\\s]*\\)"$/\\1/p' %{_includedir}/pppd/pppdconf.h 2>/dev/null | grep . || echo bad)

%define _disable_ld_no_undefined 1
%global debug_package %{nil}

%global ifcfg_migrate 0

#build customizations: 1-enabled 0-disabled
#rules: you can have nmdebuginfo 1 ONLY with more_asserts 1
#		otherwise nmdebuginfo will be 0 (disabled) because..
#		there's no sense to build debuginfo without more debug asserts
#note that debuginfo build will eat the CPU..so be patient
#------------------------------------
%define bcond_default_nmdebuginfo 0
%define bcond_default_nm_more_asserts 0
%define bcond_default_nmtest 0
%define bcond_default_meson_build 1
#------------------------------------

%define	major_glib	4
%define major_glib_vpn	1
%define major_util	2
%define major_nm	0
%define gimajor_glib	1.0
%define gimajor_util	1.0
%define gimajor_nm	1.0
%define libnm_glib		%mklibname nm-glib %{major_glib}
%define libnm_glib_devel	%mklibname -d nm-glib
%define libnm_glib_vpn		%mklibname nm-glib-vpn %{major_glib_vpn}
%define libnm_glib_vpn_devel	%mklibname -d nm-glib-vpn
%define libnm		%mklibname nm %{major_nm}
%define libnm_devel	%mklibname -d nm
%define libnm_util		%mklibname nm-util %{major_util}
%define libnm_util_devel	%mklibname -d nm-util
%define libnm_glib_gi		%mklibname nmclient-gir %{gimajor_glib}
%define libnm_util_gi		%mklibname networkmanager-gir %{gimajor_util}
%define url_ver %(echo %{version} | cut -d "." -f -2)

%define	rname	NetworkManager

# build type
%if %{bcond_default_meson_build}
%bcond_without meson
%else
%bcond_with meson
%endif

#tests
%if %{bcond_default_nmtest}
%bcond_without test
%else
%bcond_with test
%endif

#debug_asserts
%if %{bcond_default_nm_more_asserts}
%bcond_without nm_more_asserts
%else
%bcond_with nm_more_asserts
%endif

#debug_symbols
%if %{bcond_default_nmdebuginfo} && %{bcond_default_nm_more_asserts}
%bcond_without debuginfo
%else
%bcond_with debuginfo
%endif

%define	rversion	%version

Name:		networkmanager
Summary:	Network connection manager and user applications
Version:	1.46.0
Release:	%mkrel 3
Group:		System/Base
License:	GPLv2+
URL:		https://wiki.gnome.org/Projects/NetworkManager
%(if [ ! -f %_sourcedir/NetworkManager-%{rversion}.tar.xz ]; then cd %_sourcedir/ && wget https://download.gnome.org/sources/NetworkManager/%{url_ver}/NetworkManager-%{rversion}.tar.xz; fi)

Source0:	%{rname}-%{rversion}.tar.xz
Source1: 	NetworkManager
Source2:	72-wifi-wired-exclusive.sh
Source3:	71-wifi-regulatory-domain.sh
Source4:	70-nm-connectivity.conf
#------------------------------------------------------------------
#pclinux
Patch0:		NetworkManager-fixbuild-nologind.patch
Patch1:		NetworkManager-1.44.0-carrier-wait-timeout.patch

Patch2:		NetworkManager-1.32.8-drivers-rules.patch
Patch100:	NetworkManager-1.38.0-fix-tests-on-systemv.patch

# https://bugzilla.redhat.com/show_bug.cgi?id=2175919
# we're not systemD - nothing to fix!
Patch101:	NetworkManager-1.43.5-revert-5bee60bb813f8dab5885f6f5b6704bf8cf336d0e.patch

#opensuse
Patch4:		0001-Coerce-connectivity-LIMITED-to-NONE-when-device-is-d.patch
Patch5:		nm-dont-overwrite-resolv-conf.patch
Patch6:		NetworkManager-1.10.6-netconfig.patch

#upstream
Patch1001:	1001-nm-manager-ensure-device-is-exported-on-D-Bus-in-aut-rhbz2210271.patch

BuildRequires:	cmake
BuildRequires:	meson
BuildRequires:	ninja
BuildRequires:	intltool
BuildRequires:	ppp-devel
BuildRequires:  modemmanager-devel
BuildRequires:	wpa_supplicant
BuildRequires:	lib64polkit1-devel
BuildRequires:	lib64readline-devel
BuildRequires:	lib64iptables-devel
BuildRequires:	lib64nl3-devel
BuildRequires:	lib64iw30-devel
BuildRequires:	lib64girepository-devel
BuildRequires:	lib64vala-devel
BuildRequires:	lib64curl-devel
BuildRequires:	lib64uuid-devel
BuildRequires:	lib64soup-devel
BuildRequires:	lib64nss-devel
BuildRequires:	lib64newt0.52-devel
BuildRequires:	lib64ndp-devel
BuildRequires:	lib64gudev1.0-devel
BuildRequires:	lib64dbus-glib-1_2-devel
BuildRequires:	lib64bluez-devel
BuildRequires:	lib64jansson-devel
BuildRequires:	python-gobject3-devel
#tests BR
BuildRequires:	python3-pexpect
BuildRequires:	python-dbus-devel

#----------------------------------------------
Requires:	wpa_supplicant
Requires:	wireless-tools
Requires: 	dhcpcd
Requires:	mobile-broadband-provider-info
Requires:	modemmanager
Requires:	dnsmasq-base
Requires:	ppp
Requires:	iproute2
Requires:	iptables
Provides:	NetworkManager = %{version}-%{release}
Obsoletes: 	lib64nm-glib-vpn1
Obsoletes:	lib64nm-glib4
Obsoletes:	lib64nm-util2
Obsoletes:	lib64nm%{major_nm}
Provides:	lib64nm-glib-vpn1 = %{version}-%{release}
Provides:	lib64nm-glib4 = %{version}-%{release}
Provides:	lib64nm-util2 = %{version}-%{release}
Provides:	lib64nm%{major_nm} = %{version}-%{release}
#----------------------------------------------
Conflicts:	wicd
#----------------------------------------------
Requires(post):		rpm-helper
Requires(preun):	rpm-helper


%description
NetworkManager is a system service that manages network interfaces and
connections based on user or automatic configuration. It supports Ethernet,
Bridge, Bond, VLAN, Team, InfiniBand, Wi-Fi, mobile broadband (WWAN), PPPoE and
other devices, and supports a variety of different VPN services.

%package -n	%{libnm_devel}
Summary: Development files for networkmanager
Group: Development/Libraries
Provides:	libnm-devel = %{version}-%{release}
Provides:	networkmanager-devel = %{version}-%{release}
Obsoletes:	lib64nm-glib-devel
Obsoletes:	lib64nm-glib-vpn-devel
Obsoletes:	lib64nm-util-devel
Provides:	lib64nm-glib-devel = %{version}-%{release}
Provides:	lib64nm-glib-vpn-devel = %{version}-%{release}
Provides:	lib64nm-util-devel = %{version}-%{release}

%description -n %{libnm_devel}
Development files for networkmanager
%if %{with debuginfo}
%package	debuginfo
Summary: Debug files for networkmanager
Group: Development/Libraries

%description	debuginfo
Debug files for networkmanager
Provide debugsymbols in order to use with gdb as follows:
service networkmanager stop && gdb -ex run --args /usr/sbin/NetworkManager -d
then, on the gdb's shell, view the backtrace:
bt
%endif

%prep
%setup -q -n %{rname}-%{rversion}
%autopatch -p1

%build

%if %{with meson}
%define _lto_cflags %{nil}
%if %{without nm_more_asserts}
export CFLAGS+="%{optflags} -Wno-stringop-overflow"
%endif
%if %{with debuginfo}
export CFLAGS+="%{optflags} -DNDEBUG=1 -O2 -g"
%endif
export PYTHON=%{_bindir}/python3
%meson \
		-Dcrypto=nss \
		-Db_ndebug=false \
		%if %{with test}
		--werror \
		%endif
		--warnlevel 2 \
		-Dnm_cloud_setup=false \
		-Dld_gc=true \
		-Dlibpsl=true \
		%if %{with nm_more_asserts}
		-Dmore_asserts=100 \
		-Dmore_logging=true \
		%else
		-Dmore_asserts=0 \
		-Dmore_logging=false \
		%endif
		-Ddocs=false \
		-Dsystem_ca_path=/etc/pki/tls/certs \
		-Dnmtui=true \
		-Dselinux=false \
		-Dsystemdsystemunitdir=no \
		-Dsystemd_journal=false \
		-Dlibaudit=no \
		-Dsuspend_resume=consolekit \
		-Dresolvconf=yes \
		-Dconfig_dns_rc_manager_default=resolvconf \
		-Dconfig_logging_backend_default=syslog \
		-Dtests=yes \
		-Diptables=%{_sbindir}/iptables \
		-Difcfg_rh=true \
		-Difupdown=false \
		-Dconfig_plugins_default=ifcfg-rh \
		-Dbluez5_dun=true \
		-Dteamdctl=false \
		-Dmodem_manager=true \
		-Ddhclient=true \
		-Dconfig_dhcp_default=dhcpcd \
		-Ddhcpcd=true \
		-Ddhcpcanon=no \
		-Dvapi=true \
		-Dintrospection=true \
		-Dmodify_system=true \
		-Dconcheck=true \
		-Dwifi=true \
		-Dwext=true \
		-Diwd=true \
		-Dconfig_wifi_backend_default=wpa_supplicant \
		-Dsession_tracking=no \
		-Dsession_tracking_consolekit=true \
		-Dpolkit=true \
		-Dqt=false \
		-Dppp=true \
		-Dfirewalld_zone=false \
		-Dpppd_plugin_dir=%{_libdir}/pppd/%{ppp_version} \
		-Dhostname_persist=default \
		-Dudev_dir=/lib/udev \
		-Ddbus_conf_dir=/etc/dbus-1/system.d \
		-Dnetconfig=false \
		%if %{?ifcfg_migrate}
		-Dconfig_migrate_ifcfg_rh_default=true \
		%else
		-Dconfig_migrate_ifcfg_rh_default=false \
		%endif
		-Db_lto=true
		%{nil}
%meson_build
%else
#gtkdocize
autoreconf --install --force
intltoolize --automake --copy --force
%if %{with debuginfo}
export CFLAGS+="%{optflags} -DNDEBUG=1 -O2 -g -Wno-array-bounds -Wno-maybe-uninitialized"
%else
export CFLAGS+="%{optflags} -O3 -Wno-array-bounds"
%endif
%configure2_5x	--disable-static \
		--with-crypto=nss \
		--with-nm-cloud-setup=no \
		--enable-ld-gc \
		--with-libpsl \
		%if %{with nm_more_asserts}
		--enable-more-logging \
		--with-more-asserts=100 \
		%else
		--disable-more-logging \
		--without-more-asserts \
		%endif
		%if %{with test}
		--enable-more-warnings=error \
		%else
		--enable-more-warnings=yes \
		%endif
		--disable-gtk-doc \
		--with-system-ca-path=/etc/pki/tls/certs \
		--with-nmtui=yes \
		--with-selinux=no \
		--with-systemdsystemunitdir=no \
		--with-systemd-journal=no \
		--with-systemd-logind=no \
		--with-resolvconf=yes \
		--with-config-dns-rc-manager-default=resolvconf \
		--with-config-logging-backend-default=syslog \
		--with-tests=yes \
		--enable-ifcfg-rh=yes \
		--with-config-plugins-default=ifcfg-rh \
		--enable-ifupdown=no \
		--enable-teamdctl=no \
		--with-modem-manager-1=yes \
		--with-dhclient=yes \
		--with-config-dhcp-default=dhcpcd \
		--with-dhcpcd=yes \
		--with-dhcpcanon=no \
		--enable-vala=yes \
		--enable-introspection \
		--enable-modify-system=yes \
		--enable-concheck \
		--enable-wifi=yes \
		--with-wext=yes \
		--with-iwd=yes \
		--with-consolekit=yes \
		--with-session-tracking=consolekit \
		--enable-polkit=yes \
		--enable-qt=no \
		--enable-lto=yes \
		--enable-ppp=yes \
		--enable-firewalld-zone=no \
		--with-pppd-plugin-dir=%{_libdir}/pppd/%{ppp_version} \
		--with-hostname-persist=default \
		--with-udev-dir=/lib/udev \
		--with-dbus-sys-dir=/etc/dbus-1/system.d \
		%if %{?ifcfg_migrate}
		--with-config-migrate-ifcfg-rh-default=yes \
		%else
		--with-config-migrate-ifcfg-rh-default=no \
		%endif
		--with-netconfig=no

make %{?_smp_mflags} nmrundir="/var/run/%{rname}"
%endif

%install
%if %{with debuginfo}
export DONT_STRIP=0
%endif
rm -rf %buildroot
%if %{with meson}
%meson_install
%else
%make_install nmrundir="/var/run/%{rname}" STRIP=/bin/true
%endif

install -d %{buildroot}%{_libexecdir}

cat > %{buildroot}%{_sysconfdir}/NetworkManager/NetworkManager.conf << EOF
[main]
plugins=ifcfg-rh,keyfile
no-auto-default=*
# Ignore the carrier (cable plugged in) state when attempting to
# activate static-IP connections.
#ignore-carrier=*
dhcp=dhccpcd
hostname-mode=none
rc-manager=resolvconf
[device]
wifi.scan-rand-mac-address=no
EOF
#more fixes on randomization 
cat > %{buildroot}%{_sysconfdir}/NetworkManager/conf.d/30-randomize-mac-address.conf << EOF
[connection-mac-randomization]
ethernet.cloned-mac-address=permanent
wifi.cloned-mac-address=permanent
EOF

#by default - disable connectivity check
cat > %{buildroot}%{_sysconfdir}/NetworkManager/conf.d/40-conncheck.conf << EOF
# Disable connectivity checking for NetworkManager.
# See `man NetworkManager.conf`.
#
# Note that connectivity checking works badly with rp_filter set to
# strict. Check "/proc/sys/net/ipv4/conf/*/rp_filter".
[connectivity]
enabled=false
EOF

# Create netprofile module
%__install -d %{buildroot}%{_sysconfdir}/netprofile/modules/
cat > %{buildroot}%{_sysconfdir}/netprofile/modules/01_networkmanager << EOF
# netprofile module
#
# this module contains settings for saving/restore the NetworkManager configuration
# in different network profiles

NAME="NetworkManager"
DESCRIPTION="Networkmanager connection settings"

# list of files to be saved by netprofile
FILES="/etc/NetworkManager/"

# list of services to be restarted by netprofile
SERVICES="NetworkManager"
EOF
chmod  755 %{buildroot}%{_sysconfdir}/netprofile/modules/01_networkmanager

# create a VPN directory
install -d %{buildroot}%{_sysconfdir}/%{rname}/VPN

# create keyfile plugin system-settings directory
install -d %{buildroot}%{_sysconfdir}/%{rname}/system-connections

#init.d
mkdir -p %{buildroot}/%{_sysconfdir}/rc.d/init.d
install -m 0755 %SOURCE1 %{buildroot}/%{_sysconfdir}/rc.d/init.d/NetworkManager

#sysctl
mkdir -p %{buildroot}/%{_sysconfdir}/sysctl.d
cp %{SOURCE4} %{buildroot}/%{_sysconfdir}/sysctl.d

#wireless dispatchers
install -m 0755 %SOURCE2 %{buildroot}/%{_sysconfdir}/NetworkManager/dispatcher.d/72-wifi-wired-exclusive
install -m 0755 %SOURCE3 %{buildroot}/%{_sysconfdir}/NetworkManager/dispatcher.d/71-wifi-regulatory-domain
%find_lang %{rname}

# Ensure the documentation timestamps are constant to avoid multilib conflicts
%if %{without meson}
find %{buildroot}%{_datadir}/gtk-doc -exec touch --reference configure.ac '{}' \+
%endif

find %{buildroot} -name '*.la' -delete

%files -f %{rname}.lang
%{_sysconfdir}/dbus-1/system.d/org.freedesktop.NetworkManager.conf
%{_sysconfdir}/dbus-1/system.d/nm-dispatcher.conf
%{_sysconfdir}/dbus-1/system.d/nm-ifcfg-rh.conf
%{_sysconfdir}/rc.d/init.d/NetworkManager
%{_sysconfdir}/sysctl.d/70-nm-connectivity.conf
%{_sysconfdir}/%{rname}/conf.d/40-conncheck.conf
%dir %{_sysconfdir}/%{rname}
%config(noreplace) %{_sysconfdir}/%{rname}/NetworkManager.conf
%dir %{_sysconfdir}/%{rname}/conf.d
%{_sysconfdir}/%{rname}/conf.d/30-randomize-mac-address.conf
%{_sysconfdir}/netprofile/modules/01_networkmanager
%{_sbindir}/%{rname}
%dir %{_sysconfdir}/%{rname}/dispatcher.d
%{_sysconfdir}/%{rname}/dispatcher.d/72-wifi-wired-exclusive
%{_sysconfdir}/%{rname}/dispatcher.d/71-wifi-regulatory-domain
%dir %{_sysconfdir}/%{rname}/system-connections
%dir %{_sysconfdir}/NetworkManager/VPN
%{_bindir}/nmcli
%{_bindir}/nm-online
%{_libexecdir}/nm-dispatcher
%{_libexecdir}/nm-initrd-generator
%{_libexecdir}/nm-dhcp-helper
%{_libexecdir}/nm-ifdown
%{_libexecdir}/nm-ifup
%{_libexecdir}/nm-daemon-helper
%if %{without meson}
%{_mandir}/man1/*.1*
%{_mandir}/man5/*.5*
%{_mandir}/man7/*.7*
%{_mandir}/man8/*.8*
%endif
%dir %{_libdir}/NetworkManager/%{rversion}
%{_libdir}/NetworkManager/%{rversion}/*.so
%{_libdir}/pppd/*.*.*/nm-pppd-plugin.so
%{_datadir}/bash-completion/completions/nmcli
%{_datadir}/dbus-1/system-services/org.freedesktop.nm_dispatcher.service
%{_datadir}/dbus-1/interfaces/*.xml
%{_datadir}/polkit-1/actions/org.freedesktop.NetworkManager.policy
%{_datadir}/doc/NetworkManager/examples/server.conf
/lib/udev/rules.d/84-nm-drivers.rules
/lib/udev/rules.d/85-nm-unmanaged.rules
/lib/udev/rules.d/90-nm-thunderbolt.rules


%{_datadir}/dbus-1/system-services/org.freedesktop.nm_priv_helper.service
%{_libexecdir}/nm-priv-helper
#{_libexecdir}/nm-iface-helper
%{_sysconfdir}/dbus-1/system.d/nm-priv-helper.conf

%{_bindir}/nmtui
%{_bindir}/nmtui-connect
%{_bindir}/nmtui-edit
%{_bindir}/nmtui-hostname

%{_libdir}/libnm.so.%{major_nm}*
%{_libdir}/girepository-1.0/NM-%{gimajor_nm}.typelib

%files -n %{libnm_devel}
%dir %{_includedir}/libnm
%{_includedir}/libnm/*.h
%{_libdir}/pkgconfig/libnm.pc
%{_libdir}/libnm.so
%{_datadir}/gir-1.0/NM-1.0.gir
%if %{without meson}
%dir %{_datadir}/gtk-doc/html/libnm
%{_datadir}/gtk-doc/html/libnm/*
%dir %{_datadir}/gtk-doc/html/NetworkManager
%{_datadir}/gtk-doc/html/NetworkManager/*
%endif
%{_datadir}/vala/vapi/libnm.deps
%{_datadir}/vala/vapi/libnm.vapi
%{_datadir}/dbus-1/interfaces/*.xml

%if %{with debuginfo}
%files  debuginfo
/usr/lib/debug/*
/usr/lib/debug/.build-id
%exclude /usr/src/
%endif

%pre
#kill networkmanager as now is NetworkManager
if [ -e /var/lock/subsys/networkmanager ]; then
pid=`/sbin/pidof -x networkmanager`
[ -n "$pid" ] && service networkmanager stop
rm -f /var/lock/subsys/networkmanager >/dev/null 2>&1 || :
fi
if [ -e /etc/rc.d/init.d/networkmanager ]; then
/sbin/chkconfig --del networkmanager >/dev/null 2>&1
fi
#start with new default with hostname-mode=none
rm -f %{_sysconfdir}/%{rname}/NetworkManager.conf

%preun
%_preun_service NetworkManager
if [ $1 -eq 0 ]; then
    /usr/sbin/update-alternatives --remove ifup %{_libexecdir}/nm-ifup >/dev/null 2>&1 || :
fi

%post
/sbin/udevadm control --reload-rules || :
/sbin/udevadm trigger --subsystem-match=net || :
# don't know why chkconfig starts the daemon in other S than S12, so do a reset to ensure everthing is OK at next reboot
%_post_service NetworkManager
/sbin/chkconfig NetworkManager reset >/dev/null 2>&1
service NetworkManager restart >/dev/null 2>&1

%postun
/sbin/udevadm control --reload-rules || :
/sbin/udevadm trigger --subsystem-match=net || :

%triggerin -- initscripts
if [ -f %{_sbindir}/ifup -a ! -L %{_sbindir}/ifup ]; then
    # initscripts package too old, won't let us set an alternative
    /usr/sbin/update-alternatives --remove ifup %{_libexecdir}/nm-ifup >/dev/null 2>&1 || :
else
    /usr/sbin/update-alternatives --install %{_sbindir}/ifup ifup %{_libexecdir}/nm-ifup 50 \
        --slave %{_sbindir}/ifdown ifdown %{_libexecdir}/nm-ifdown
fi

%posttrans
rm -f /etc/sysconfig/network-scripts/keys-TEXSTAR >/dev/null 2>&1
echo "A reboot may be required to restore your network connection."

%check
%if %{with meson}
%if %{with test}
%meson_test
%else
%ninja_test -C %{_vpath_builddir} || :
%endif
%else
# autotools
%if %{with test}
make -k %{?_smp_mflags} check
%else
make -k %{?_smp_mflags} check || :
%endif
%endif

%changelog
* Mon Apr 22 2024 yodelu - 1.46.0-3pclos2024
- rename initscript networkmamager > NetworkManager

* Tue Feb 27 2024 yodelu - 1.46.0-2pclos2024
- fix 72-wifi-wired-exclusive script

* Sat Feb 24 2024 yodelu - 1.46.0-1pclos2024
- new version

* Thu Feb 06 2024 yodelu - 1.44.2-2pclos2024
- switch to dhcpcd since dhcp-client got dropped

* Thu Oct 5 2023 yodelu - 1.44.2-1pclos2023
- version update

* Mon Sep 06 2023 yodelu - 1.44.0-3pclos2023
- replace p0 (as udev is 243)
- add p101 (systemD fixes it broke systemV)
- redo changes on p1
- increase wait-online time to 20s
